/* Do not edit. Autogenerated from cputype.table */
#include <stddef.h>

#include "cputype.h"

#include "config.h"

enum cputype lookup_intel_cputype(int model)
{
	switch (model) {
	case 0x97:
	case 0x9A:
	case 0xBE:
		return CPU_ALDERLAKE;
	case 0x1c:
	case 0x26:
	case 0x27:
	case 0x35:
	case 0x36:
	case 0x37:
	case 0x4a:
	case 0x4c:
	case 0x4d:
	case 0x5a:
	case 0x5d:
		return CPU_ATOM;
	case 0x3d:
	case 0x47:
		return CPU_BROADWELL;
	case 0x56:
		return CPU_BROADWELL_DE;
	case 0x4f:
		return CPU_BROADWELL_EPEX;
	case 0xa5:
	case 0xa6:
		return CPU_COMETLAKE;
	case 0xf:
	case 0x17:
		return CPU_CORE2;
	case 0x5f:
		return CPU_DENVERTON;
	case 0x1d:
		return CPU_DUNNINGTON;
	case 0x3c:
	case 0x45:
	case 0x46:
		return CPU_HASWELL;
	case 0x3f:
		return CPU_HASWELL_EPEX;
	case 0x7D:
	case 0x7E:
	case 0x9D:
		return CPU_ICELAKE;
	case 0x6C:
		return CPU_ICELAKE_DE;
	case 0x6A:
		return CPU_ICELAKE_XEON;
	case 0x3a:
		return CPU_IVY_BRIDGE;
	case 0x3e:
		return CPU_IVY_BRIDGE_EPEX;
	case 0x8E:
	case 0x9E:
		return CPU_KABYLAKE;
	case 0x57:
		return CPU_KNIGHTS_LANDING;
	case 0x85:
		return CPU_KNIGHTS_MILL;
	case 0x8A:
		return CPU_LAKEFIELD;
	case 0x1a:
	case 0x2c:
	case 0x1e:
	case 0x25:
		return CPU_NEHALEM;
	case 0x0:
	case 0x1:
	case 0x2:
	case 0x3:
	case 0x4:
	case 0x5:
	case 0x6:
	case 0x7:
	case 0x8:
	case 0x9:
	case 0xA:
	case 0xB:
	case 0xC:
	case 0xD:
	case 0xE:
		return CPU_P6OLD;
	case 0xb7:
	case 0xba:
	case 0xbf:
		return CPU_RAPTORLAKE;
	case 0xA7:
		return CPU_ROCKETLAKE;
	case 0x2a:
		return CPU_SANDY_BRIDGE;
	case 0x2d:
		return CPU_SANDY_BRIDGE_EP;
	case 0x8F:
		return CPU_SAPPHIRERAPIDS;
	case 0x4e:
	case 0x5e:
		return CPU_SKYLAKE;
	case 0x55:
		return CPU_SKYLAKE_XEON;
	case 0x8C:
	case 0x8D:
		return CPU_TIGERLAKE;
	case 0x86:
		return CPU_TREMONT_D;
	case 0x2e:
	case 0x2f:
		return CPU_XEON75XX;
	default:
		return -1;
	}
}

char *cputype_name[] = {
	[CPU_GENERIC] = "generic CPU",
	[CPU_K8] = "AMD K8 and derivates",
	[CPU_INTEL] = "Intel generic architectural MCA",
	[CPU_P4] = "Intel P4",
	[CPU_TULSA] = "Intel Xeon 7100 series",
	[CPU_ALDERLAKE] = "Alderlake",
	[CPU_ATOM] = "ATOM",
	[CPU_BROADWELL] = "Broadwell",
	[CPU_BROADWELL_DE] = "Intel Xeon (Broadwell) D family",
	[CPU_BROADWELL_EPEX] = "Intel Xeon v4 (Broadwell) EP/EX",
	[CPU_COMETLAKE] = "Cometlake",
	[CPU_CORE2] = "Intel Core",
	[CPU_DENVERTON] = "Denverton",
	[CPU_DUNNINGTON] = "Intel Xeon 7400 series",
	[CPU_HASWELL] = "Intel Xeon v3 (Haswell) EP/EX",
	[CPU_HASWELL_EPEX] = "Haswell",
	[CPU_ICELAKE] = "Icelake server D Family",
	[CPU_ICELAKE_DE] = "Icelake",
	[CPU_ICELAKE_XEON] = "Icelake server",
	[CPU_IVY_BRIDGE] = "Intel Xeon v2 (Ivy Bridge) EP/EX",
	[CPU_IVY_BRIDGE_EPEX] = "Ivy Bridge",
	[CPU_KABYLAKE] = "Kabylake",
	[CPU_KNIGHTS_LANDING] = "Knights Landing",
	[CPU_KNIGHTS_MILL] = "Knights Mill",
	[CPU_LAKEFIELD] = "Lakefield",
	[CPU_NEHALEM] = "Intel Xeon 5500 series / Core i3/5/7 (\"Nehalem/Westmere\")",
	[CPU_P6OLD] = "Intel PPro/P2/P3/old Xeon",
	[CPU_RAPTORLAKE] = "Raptorlake",
	[CPU_ROCKETLAKE] = "Rocketlake",
	[CPU_SANDY_BRIDGE] = "Sandy Bridge EP",
	[CPU_SANDY_BRIDGE_EP] = "Sandy Bridge",
	[CPU_SAPPHIRERAPIDS] = "Sapphirerapids server",
	[CPU_SKYLAKE] = "Skylake",
	[CPU_SKYLAKE_XEON] = "Skylake server",
	[CPU_TIGERLAKE] = "Tigerlake",
	[CPU_TREMONT_D] = "Tremont microserver",
	[CPU_XEON75XX] = "Intel Xeon 7500 series",

};

struct config_choice cpu_choices[] = {
	{ "generic", CPU_GENERIC },
	{ "k8", CPU_K8 },
	{ "intel", CPU_INTEL },
	{ "p4", CPU_P4 },
	{ "xeon5000", CPU_P4 },
	{ "xeon7100", CPU_P4 },
	{ "tulsa", CPU_TULSA },
	{ "xeon7100", CPU_TULSA },
	{ "xeon71xx", CPU_TULSA },
	{ "alderlake",CPU_ALDERLAKE },
	{ "atom",CPU_ATOM },
	{ "broadwell",CPU_BROADWELL },
	{ "broadwell-d",CPU_BROADWELL_DE },
	{ "broadwell-ep",CPU_BROADWELL_EPEX },
	{ "broadwell-ex",CPU_BROADWELL_EPEX },
	{ "xeon-v4",CPU_BROADWELL_EPEX },
	{ "cometlake",CPU_COMETLAKE },
	{ "core2",CPU_CORE2 },
	{ "xeon3100",CPU_CORE2 },
	{ "xeon3200",CPU_CORE2 },
	{ "xeon5100",CPU_CORE2 },
	{ "xeon5200",CPU_CORE2 },
	{ "xeon7200",CPU_CORE2 },
	{ "denverton",CPU_DENVERTON },
	{ "dunnington",CPU_DUNNINGTON },
	{ "xeon7400",CPU_DUNNINGTON },
	{ "xeon74xx",CPU_DUNNINGTON },
	{ "haswell-ep",CPU_HASWELL },
	{ "haswell-ex",CPU_HASWELL },
	{ "xeon-v3",CPU_HASWELL },
	{ "haswell",CPU_HASWELL_EPEX },
	{ "icelake",CPU_ICELAKE },
	{ "icelake-d",CPU_ICELAKE_DE },
	{ "icelake_server",CPU_ICELAKE_XEON },
	{ "ivybridge-ep",CPU_IVY_BRIDGE },
	{ "ivybridge-ex",CPU_IVY_BRIDGE },
	{ "xeon-v2",CPU_IVY_BRIDGE },
	{ "ivybridge",CPU_IVY_BRIDGE_EPEX },
	{ "kabylake",CPU_KABYLAKE },
	{ "knightslanding",CPU_KNIGHTS_LANDING },
	{ "knightsmill",CPU_KNIGHTS_MILL },
	{ "lakefield",CPU_LAKEFIELD },
	{ "core_i3",CPU_NEHALEM },
	{ "core_i5",CPU_NEHALEM },
	{ "core_i7",CPU_NEHALEM },
	{ "nehalem",CPU_NEHALEM },
	{ "westmere",CPU_NEHALEM },
	{ "xeon5500",CPU_NEHALEM },
	{ "p6old",CPU_P6OLD },
	{ "raptorlake",CPU_RAPTORLAKE },
	{ "rocketlake",CPU_ROCKETLAKE },
	{ "sandybridge",CPU_SANDY_BRIDGE },
	{ "sandybridge-ep",CPU_SANDY_BRIDGE_EP },
	{ "sapphirerapids_server",CPU_SAPPHIRERAPIDS },
	{ "skylake",CPU_SKYLAKE },
	{ "cascadelake_server",CPU_SKYLAKE_XEON },
	{ "skylake_server",CPU_SKYLAKE_XEON },
	{ "tigerlake",CPU_TIGERLAKE },
	{ "snowridge",CPU_TREMONT_D },
	{ "xeon7500",CPU_XEON75XX },
	{ "xeon75xx",CPU_XEON75XX },
	{ NULL }
};
